---
title: Toolbox
slug: Tools/Tools_Toolbox
---
<div>{{ToolsSidebar}}</div>

<p>The Toolbox provides a single home for most of the developer tools that are built into Firefox.</p>

<p>There are a few different ways to open the Toolbox:</p>

<ul>
 <li>select "Toggle Tools" from the Web Developer menu (under "Tools" on OS X and Linux, or "Firefox" on Windows)</li>
 <li>click the wrench icon (<img alt="" src="https://mdn.mozillademos.org/files/12710/wrench-icon.png" style="height: 21px; width: 21px;">), which is in the main toolbar or under the Hamburger menu (<img alt="" src="https://mdn.mozillademos.org/files/12712/hamburger.png" style="height: 20px; width: 22px;">), then select "Toggle Tools"</li>
 <li>activate any tool hosted in the Toolbox (for example, the JavaScript Debugger or the Page Inspector)</li>
 <li>press <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>I</kbd> on Windows and Linux, or <kbd>Cmd</kbd> + <kbd>Opt</kbd> + <kbd>I</kbd> on OS X. See also <a href="/en-US/docs/Tools/Keyboard_shortcuts">keyboard shortcuts</a>.</li>
</ul>

<p>By default, the window appears docked to the bottom side of the Firefox window, but you can detach it if you like. This is what it looks like when it's docked:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6923/toolbox.png" style="display: block; margin-left: auto; margin-right: auto;">The window itself is split into two parts: a toolbar along the top, and a main pane underneath:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6925/toolbox-annotated-29.png" style="display: block; height: 471px; margin-left: auto; margin-right: auto; width: 876px;"></p>

<div class="note">
<p><strong>Note</strong>: Since Firefox 62, you can drag and drop tabs in the main toolbar of the toolbox to reorder your tools as you wish ({{bug(1226272)}}).</p>
</div>

<h2 id="Docking_mode">Docking mode</h2>

<p>By default, the Toolbox appears docked to the bottom of the browser window, but you can also dock it to the right-hand side of the window, or make it a standalone window, using <a href="/en-US/docs/Tools/Tools_Toolbox#Toolbox_controls">buttons in the toolbar</a>.</p>

<h2 id="Toolbar">Toolbar</h2>

<p>The toolbar contains controls to activate a particular tool, to dock/float the window, and to close the window.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/7913/toolbox-toolbar-annotated.png" style="display: block; margin-left: auto; margin-right: auto;"></p>

<h3 id="Node_picker">Node picker</h3>

<p>On the far left there's a button to activate the node picker. This lets you select a page element for inspection. See <a href="/en-US/docs/Tools/Page_Inspector/How_to/Select_an_element">"Selecting elements"</a>.</p>

<h3 id="Toolbox-hosted_tools">Toolbox-hosted tools</h3>

<p>Then there is an array of labeled buttons which enables you to switch between the different tools hosted by the Toolbox. The array may include the following tools:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Web_Console">Web Console</a></li>
 <li><a href="/en-US/docs/Tools/Debugger">JavaScript Debugger</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a></li>
 <li><a href="/en-US/docs/Tools/Style_Editor">Style Editor</a></li>
 <li><a href="/en-US/docs/Tools/Profiler" title="/en-US/docs/Performance/Profiling_with_the_Built-in_Profiler">Profiler</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor" title="/en-US/docs/Performance/Profiling_with_the_Built-in_Profiler">Network Monitor</a></li>
</ul>

<p>Note that not all the hosted tools are always listed here: only the tools actually available in this context are shown (for example, not all tools support remote debugging yet, so if the debugging target is not the Firefox instance that launched the window, not all the hosted tools will be shown).</p>

<h3 id="Extra_tools">Extra tools</h3>

<p>Next there's an array of buttons that can be added or removed in the <a href="#Settings">developer tool settings</a>. By default this array includes:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Web_Console#The_split_console">Toggle split console</a></li>
 <li><a href="/en-US/docs/Tools/Responsive_Design_View">Responsive Design Mode</a></li>
 <li><a href="/en-US/docs/tools/Working_with_iframes">Select a frame as the currently targeted document</a> (this is only included by default from Firefox 41 onwards).</li>
</ul>

<p>The following tools are not included in the toolbar by default, but you can add them in the <a href="#Settings">settings</a>:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Paint_Flashing_Tool">Highlight painted area</a></li>
 <li><a href="/en-US/docs/Tools/3D_View">3D view</a> (note that this is not available in Firefox 40)</li>
 <li><a href="/en-US/docs/Tools/Scratchpad">Scratchpad</a></li>
 <li><a href="/en-US/docs/Tools/Eyedropper">Grab a color from the page</a></li>
 <li>Take a screenshot of the entire page: take a screenshot of the complete web page and saves it in your Downloads directory</li>
 <li><a href="/en-US/docs/Tools/Rulers">Toggle rulers for the page</a></li>
 <li>Measure a portion of the page: measure a part of the website by selecting areas within the page</li>
</ul>

<h3 id="Toolbox_controls">Toolbox controls</h3>

<p>Finally there's a row of buttons to:</p>

<ul>
 <li>close the window</li>
 <li>toggle the window between attached to the bottom of the browser window, and attached to the side of the browser window</li>
 <li>toggle the window between standalone and attached to the browser window</li>
 <li>access <a href="#Settings">developer tool settings</a></li>
</ul>

<h2 id="Settings_2"><a name="Settings">Settings</a></h2>

<p><a href="/en-US/docs/Tools/Settings">See the separate page on the Developer Tools Settings</a>.</p>

<h2 id="Main_Pane">Main Pane</h2>

<p>The content of the main pane in the window is entirely controlled by, and specific to, the hosted tool currently selected.</p>

<h2 id="Keyboard_shortcuts">Keyboard shortcuts</h2>

<p>{{ Page ("en-US/docs/tools/Keyboard_shortcuts", "toolbox-shortcuts") }}</p>

<p>{{ Page ("en-US/docs/tools/Keyboard_shortcuts", "all-toolbox-tools") }}</p>
